# @(#)(schoolLAN) $Id: client.sh,v 1.4 2004/09/08 07:39:57 wytze Exp $

# this file will be called and run from the workstation
# use mirror -d to set the debug option
# if run as mirror -d you will be able to interrupt the script
# and get a shell prompt at the workstation via
# push left and right mouse button simultaneously
# push <cntrl>c if needed to get the shell prompt
#

if ! grep -q "bzImage.*-d" /proc/cmdline
then
    # trap a few signals to prevent illegal actions
    stty intr undef quit undef start undef stop undef susp undef
    trap "reboot" 0
fi

# Windows workstation specifics. Get instructions from the server
client_system () {
	if [ -f ${1}/system.sh ]
	then
		if [ ! -s ${1}/system.sh ] ; then return ; fi
		cp ${1}/system.sh /tmp/system.sh
	elif [ -f /mnt/net/$2/default/system.sh ]
	then
		cp /mnt/net/$2/default/system.sh /tmp/system.sh
	else
		return 0
	fi
	if [ ! -s /tmp/system.sh ] ; then return 0 ; fi
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME}" --infobox "Werkstation Windows specifieke zaken." 12 60
	/bin/sh /tmp/system.sh
}

# create image from primary partition
make_image () {
	eval `grep ^GATEWAY= /etc/dhcpc/dhcpcd-eth0.info`
	OS="NULL"
	OS1="off"
	OS2="off"
	OS3="off"
	/bin/mount -r /dev/hda1 /mnt/hd
	if [ -r /mnt/hd/ntldr -o -r /mnt/hd/NTLDR ]
	then
		OS="winxp"
		OS2="on"
	elif [ -r /mnt/hd/io.sys -o -r /mnt/hd/IO.SYS ]
	then
		OS="win98"
		OS1="on"
	else
		OS3="on"
	fi
	RESULT=`${DIALOG} --title "Backup maken van ${OS}" --radiolist "Operating system" 12 60 3 1 "Windows 98" ${OS1} 2 "Windows XP op FAT32" ${OS2} 3 "Ander OS" ${OS3} 2>&1`
	case ${RESULT} in
		1)
			OS="win98"
			;;
		2)
			OS="winxp"
			;;
		3)
			if [ ${DIALOG} = '/bin/dialog' ]
			then
				${DIALOG} --title "Backup maken van ${OS}" --msgbox "OS wordt (nog) niet ondersteund\nDruk op <ENTER> om te herstarten" 12 60
			else
			${DIALOG} --title "Backup maken van ${OS}" --msgbox "OS wordt (nog) niet ondersteund\nKlik op <OK> om te herstarten" 12 60
			fi
			reboot
			;;
	esac
	rpc.portmap
	mount ${GATEWAY}:/tftpboot/images /mnt/net
	MERK=""
	TYPE=""
	REDO=y
	while [ ${REDO} = "y" ]
	do
		OMERK=${MERK}
		OTYPE=${TYPE}
		MERK=""
		TYPE=""
		while [ "X${MERK}" = "X" ]
		do
			RESULT=`${DIALOG} --title "Backup maken van ${OS}" --inputbox "Merk:" 12 60 "${OMERK}" 2>&1`
			MERK=`echo ${RESULT} | sed -e 'sX X_Xg'`
		done
		while [ "X${TYPE}" = "X" ]
		do
			RESULT=`${DIALOG} --title "Backup maken van ${OS}" --inputbox "Type:" 12 60 "${OTYPE}" 2>&1`
			TYPE=`echo ${RESULT} | sed -e 'sX X_Xg'`
		done
		BUNAME="${MERK}_${TYPE}"
		# get access to partition to image by mounting it
		if [ ! -d /mnt/net/${OS}/${BUNAME} ]
		then
			mkdir /mnt/net/${OS}/${BUNAME}
			REDO=n
		else
			ANSWER=$(${DIALOG} --title "Backup maken van ${OS}" --yesno "${BUNAME} bestaat reeds!\nHuidige versie overschrijven?" 12 60)
			RETVAL=$?
			# hack needed because the current ndialog (no source available :-( )
			# always returns 0 for --yesno, but writes "Yes!" or "No..." to stdout
			[ ${DIALOG} = "/bin/ndialog" ] && [ ${ANSWER} = "No..." ] && RETVAL=1
			if [ ${RETVAL} -eq 0 ]
			then
				rm -f /mnt/net/${OS}/${BUNAME}/image.tar.gz
				REDO=n
			fi
		fi
	done
	PARTSIZE=`df -k /mnt/hd | grep hda1 | sed 'sX  *X Xg' | cut -d' ' -f2`
	PARTSIZE=$((${PARTSIZE}/1024))
	PARTUSE=`df -k /mnt/hd | grep hda1 | sed 'sX  *X Xg' | cut -d' ' -f3`
	PARTUSE=$((${PARTUSE}/1024))
	# trial: 2.3:1 for XP, 1.9:1 for 98
	if [ ${OS} = "winxp" ]
	then
		IMGSIZE=$((${PARTUSE}*10/23))
	else
		IMGSIZE=$((${PARTUSE}*10/19))
	fi
	umount /mnt/hd
	${DIALOG} --title "Backup maken van ${OS}" --infobox "Toegang tot harde schijf verkrijgen" 12 60
	/bin/mount /dev/hda1 /mnt/hd
	# create compressed tarball containing all files
	PERCENT="" ; CURSIZE=""; EXCL=""
	cd /mnt/hd
	if [ "${OS}" = "win98" ]
	then
		# busybox/tar file exclusion handling is currently
		# limited to filenames rather than pathnames and is
		# *not* case-insensitive like the vfat file system!
		cat >/tmp/EXCLS <<EOF
[Tt][Ee][Mm][Pp]
*.[Pp][Ww][Ll]
[Ss][Cc][Hh][Ee][Dd][Ll][Oo][Gg].[Tt][Xx][Tt]
*.[Tt][Mm][Pp]
[Pp][Rr][Oo][Ff][Ii][Ll][Ee][Ss]
EOF
		EXCL="--exclude-from /tmp/EXCLS"
		SWAP=windows/win386.swp
		if [ -f ${SWAP} ]
		then
			${DIALOG} --title "Backup maken van ${OS}" --infobox "Win98 swap bestand wordt opgeschoond" 12 60
			BSIZE=10240
			CURSIZE=`ls -l ${SWAP} | sed -e 'sX  *X Xg' | cut -d' ' -f5`
			CURSIZE=$((${CURSIZE}/${BSIZE}))
			dd if=/dev/zero of=${SWAP} bs=${BSIZE} count=${CURSIZE} >/dev/null 2>&1
		fi
	fi
	# for win2k and winxp page file should be cleared as well
	${DIALOG} --title "Backup maken van ${OS}" --infobox "Backup wordt gemaakt" 12 60
	(rm -f /tmp/finished
		/bin/tar cfz /mnt/net/${OS}/${BUNAME}/image.tar.gz ${EXCL} .
		if [ "$OS" = "win98" ] ; then rm -f /tmp/EXCLS ; fi
		touch /tmp/finished)& > /dev/null 2>&1
	(sleep 5
	while [ ! -f /tmp/finished ]
	do
		CURSIZE=`ls -l /mnt/net/${OS}/${BUNAME}/image.tar.gz | sed -e 'sX  *X Xg' | cut -d' ' -f5`
		CURSIZE=$((${CURSIZE}/10240))
		PERCENT=$((${CURSIZE}/${IMGSIZE}))
		# We cannot be accurate, so beware and be fooled!
		[ ${PERCENT} -gt 99 ] && PERCENT=99
		sleep 5
		echo ${PERCENT}
	done
	echo 100) | ${DIALOG} --title "Backup maken van ${OS}" --gauge "Voortgang" 12 60
	echo "PARTSIZE=${PARTSIZE}" > /mnt/net/${OS}/${BUNAME}/values
	echo "PARTUSE=${PARTUSE}" >> /mnt/net/${OS}/${BUNAME}/values
	
	# unmount partition and flush buffers
	${DIALOG} --title "Backup maken van ${OS}" --infobox "Buffers worden geleegd" 12 60
	cd /
	umount /mnt/hd
	umount /mnt/net
	sync
	${DIALOG} --title "Backup maken van ${OS}" --msgbox "Image is gemaakt...\nVoer ${OS} en ${BUNAME} in voor werkstations\nmet dit image in /etc/schoolLAN/machines" 12 60
}

# create partition and restore image
restore_image () {
	eval `grep ^GATEWAY= /etc/dhcpc/dhcpcd-eth0.info`
	eval `grep ^HOSTNAME= /etc/dhcpc/dhcpcd-eth0.info`
	rpc.portmap
	mount ${GATEWAY}:/tftpboot/images /mnt/net
	IMAGENAME=`sed 'sX#.*XX' /mnt/net/database/machines | grep ${HOSTNAME} |\
		sed 'sX[	 ][	 ]*X	Xg' | cut -d '	' -f4`
	OS=`sed 'sX#.*XX' /mnt/net/database/machines | grep ${HOSTNAME} |\
		sed 'sX[	 ][	 ]*X	Xg' | cut -d '	' -f5`
	IMAGE=/mnt/net/${OS}/${IMAGENAME}
	if [ ! -d ${IMAGE} ]
	then
		if [ ${DIALOG} = "/bin/dialog" ]
		then
			${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --msgbox "Image ${IMAGENAME} voor ${OS}\nkan niet gevonden worden!\nControleer /etc/schoolLAN/machines\nDruk op <ENTER> om te herstarten" 12 60
		else
			${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --msgbox "Image ${IMAGENAME} voor ${OS}\nkan niet gevonden worden!\nControleer /etc/schoolLAN/machines\nKlik op <OK> om te herstarten" 12 60
		fi
		reboot
	fi
	eval `grep PARTUSE ${IMAGE}/values`
	eval `grep PARTSIZE ${IMAGE}/values`
	if [ -z ${PARTSIZE} ]
	then
		PART_SIZE=0
	else
		PART_SIZE=${PARTSIZE}
	fi
	ANSWER=$(${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --yesno "Alle informatie op de harde schijf\nzal verloren gaan!\nWeet u zeker dat u door wil gaan?" 12 60)
	RETVAL=$?
	# hack needed because the current ndialog (no source available :-( )
	# always returns 0 for --yesno, but writes "Yes!" or "No..." to stdout
	[ ${DIALOG} = "/bin/ndialog" ] && [ ${ANSWER} = "No..." ] && RETVAL=1
	if [ ${RETVAL} -eq 1 ]
	then
		return 1
	fi
	MIN_PART_SIZE=$((${PARTUSE}*11/10))
	while [ $PART_SIZE -lt ${MIN_PART_SIZE} ]
	do
		RESULT=`${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --inputbox "Partitie grootte:" 12 60 ${PARTSIZE} 2>&1`
		PART_SIZE=$RESULT
		if [ "X$PART_SIZE" = "X" ]
		then
			PART_SIZE=${PARTSIZE}
		fi
	done
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Harde schijf wordt geschoond" 12 60
	# remove partition information
	# first extended partitions in dumb loop
	RET_VAL=0
	while [ $RET_VAL -ne 1 ]
	do
		/usr/sbin/parted -s /dev/hda rm 5 > /dev/null 2>&1
		RET_VAL=$?
	done
	# then primary (and extended) in similar dumb loop
	for i in 4 3 2 1
	do
		/usr/sbin/parted -s /dev/hda rm $i > /dev/null 2>&1
	done
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Harde schijf wordt ingedeeld" 12 60
	# create 1st primary with fat32 file system
	if [ ! -b /dev/hda1 ]
	then
		rm -f /dev/hda1
		mknod /dev/hda1 b 3 1
	fi
	/usr/sbin/parted -s /dev/hda mkpartfs primary fat32 0 $PART_SIZE >/dev/null 2>&1
	# save partition information from boot sector
	# create new boot sector(s)
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Harde schijf wordt bootable gemaakt" 12 60
	if [ ${OS} = "winxp" ]
	then
		/sbin/ms-sys --force --fat32xp /dev/hda1 > /dev/null 2>&1
		/sbin/ms-sys --force --mbr /dev/hda > /dev/null 2>&1
	else
		/sbin/ms-sys --force --fat32 /dev/hda1 > /dev/null 2>&1
		/sbin/ms-sys --force --mbr /dev/hda > /dev/null 2>&1
	fi
	# make primary partition bootable
	/usr/sbin/parted -s /dev/hda set 1 boot on >/dev/null 2>&1
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Toegang tot harde schijf wordt gemaakt" 12 60
	# mount newly created partition
	/bin/mount /dev/hda1 /mnt/hd > /dev/null 2>&1
	# and restore image
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Image wordt op harde schijf geplaatst" 12 60
	(rm -f /tmp/finished
		cd /mnt/hd
		/bin/tar xfz ${IMAGE}/image.tar.gz
		touch /tmp/finished)& > /dev/null 2>&1
	(sleep 5;
	while [ ! -f /tmp/finished ]
	do
		DISKUSE=`df -k /mnt/hd | grep hda1 | sed 'sX  *X Xg' | cut -d' ' -f3`
		DISKUSE=$((${DISKUSE}/10))
		PERCENT=$((${DISKUSE}/${PARTUSE}))
		[ ${PERCENT} -gt 99 ] && PERCENT=99
		sleep 5
		echo ${PERCENT}
	done
	echo 100) | ${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --gauge "Voortgang" 12 60
	# see if we can run workstation specific shell
	client_system ${IMAGE} ${OS}
	# if it is possible to install something extra, do it now!
	for FILE in /mnt/net/extra/*.sh
	do
		if [ -f ${FILE} ]
		then
			${DIALOG} --title "Image terugplaatsen ${IMAGENAME}" --infobox "Uitvoeren ${FILE}" 12 60
			ash ${FILE}
		fi
	done
	# create missing directories for win98
	if [ "${OS}" = "win98" ]
	then
		mkdir -p /mnt/hd/windows/temp
		mkdir -p /mnt/hd/windows/Profiles
	fi
	# flush buffers and unmount partition
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --infobox "Buffers worden geleegd" 12 60
	cd /
	sync
	umount /mnt/hd
	umount /mnt/net
	# Done!
	${DIALOG} --title "Image terugplaatsen ${IMAGENAME} ${OS}" --msgbox "Image is teruggezet" 12 60
}

VESAFB=0
export VESAFB
grep -i vesa /proc/fb > /dev/null 2>&1
if [ $? -eq 0 ]
then
	VESAFB=1
fi

DIALOG=/bin/dialog
export DIALOG

if [ ${VESAFB} -eq 1 ]
then
	/usr/bin/nano-X > /dev/null 2>&1 &
	sleep 1
	/bin/ndialogs
	sleep 1
	DIALOG=/bin/ndialog
fi

# repeat until a valid response has been received
todo=0
while [ "$todo" -eq "0" ]
do
	RESULT=`${DIALOG} --radiolist "Maak uw keuze" 12 60 3 1 "Systeem herstellen" on 2 "Backup maken van systeem" off 2>&1`

	case $RESULT in
		2)
			todo=1
			;;

		1)
			todo=2
			;;
			
		3)
			todo=3
			;;

		*)
			todo=0
			;;
	esac
done

if [ "$todo" -eq "3" ]
then
	exec /bin/ash
fi
if [ "$todo" -eq "1" ]
then
	make_image
else
	restore_image
fi
if [ ${DIALOG} = '/bin/dialog' ]
then
	${DIALOG} --msgbox "Verwijder de floppydisk als deze aanwezig is.\nDruk op <ENTER> om te herstarten" 12 60
else
	${DIALOG} --msgbox "Verwijder de floppydisk als deze aanwezig is.\nKlik op <OK> om te herstarten" 12 60
fi
reboot
