# Variabelen uit DHCP informatie gelezen:
# IPADDR: IP adres
# NETMASK: netwerk masker
# HOSTNAME: machine naam
# NISDOMAIN: werkgroep
# DOMAIN: SchoolLan domein
#
# Opmerkingen:
#
# een dubbele quote (het karakter ") dient voorafgegaan te worden door
# een backslash (\)
# Dit is een Linux shell script 'probleem'
#
# Een regel dient afgesloten te worden door een control-M (^M)
# Onder DOS/Windows gebeurt dit automatisch wanneer een text bestand wordt
# weggeschreven.
# Onder Linux kan dit in de editor 'vi' door control-V en control-M direct
# achter elkaar in te toetsen. Voor andere editors: zie de betreffende
# handleiding.
# Een alternatieve methode is het copieren van een complete regel, en daar
# alleen de leesbare karakters te verwijderen.
# Een derde methode is het gebruik van het commando 'unix2dos':
# unix2dos system.reg
# Gebruik in dat geval in ieder geval niet het commando dos2unix; dit zal
# de ^M aan het begin van de laatste regel verwijderen, terwijl deze
# noodzakelijk is en niet door unix2dos teruggezet zal worden.
# 
# this shell file is run on the pxe unix workstation
# a standard mount is done for executing this shell file:
# /mnt/hd as the windows system disk "/dev/hda1"
# the server /mnt/net as $GATEWAY:/tftpboot/images
#
if [ -s /etc/dhcpc/dhcpcd-eth0.info ]
then
   .  /etc/dhcpc/dhcpcd-eth0.info
fi

echo "[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\Class\NetTrans\0001]
\"IPAddress\"=\"${IPADDR}\"
\"IPMask\"=\"${NETMASK}\"
\"DefaultGateway\"=\"${GATEWAY}\"

[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\VxD\VNETSUP]
\"ComputerName\"=\"${HOSTNAME}\"
\"Workgroup\"=\"${NISDOMAIN}\"
\"Comment\"=\"Loaded by Linus.\"
\"FileSharing\"=\"Yes\"
\"PrintSharing\"=\"No\"

[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\VxD\MSTCP]
\"EnableDNS\"=\"1\"
\"HostName\"=\"${HOSTNAME}\"
\"Domain\"=\"${DOMAIN}\"
\"SearchList\"=\"${DOMAIN}\"
\"NameServer\"=\"${DNS}\"

[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\MSNP32\NetworkProvider]
\"AuthenticatingAgent\"=\"${NISDOMAIN}\"

[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\ComputerName\ComputerName]
\"ComputerName\"=\"${HOSTNAME}\"

[HKEY_LOCAL_MACHINE\Network\Logon]
\"PrimaryProvider\"=\"Microsoft Network\"
\"PolicyHandler\"=\"GROUPPOL.DLL,ProcessPolicies\"
\"logonvalidated\"=hex:01,00,00,00
\"DontShowLastUser\"=dword:00000001
\"LMLogon\"=dword:00000001
\"NoDomainPwdCaching\"=dword:00000001
\"UserProfiles\"=dword:00000001

[HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Policies\Network]
\"HideSharePwds\"=dword:00000001
\"DisablePwdCaching\"=dword:00000001
\"MinPwdLen\"=dword:00000005

[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\TimeZoneInformation]
\"DisableAutoDayLightTimeSet\"=dword:00000001

[HKEY_LOCAL_MACHINE\Security\Provider]
\"Platform_Type\"=hex:00,00,00,00

[HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Setup]
\"SourcePath\"=\"I:\\\\Win98SEcab\"

[HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Network\LanMan\ROOT$]
\"Remark\"=\"schoolLAN. Reinstalled by Linus.\"
\"Flags\"=dword:00000192
\"Type\"=dword:00000000
\"Path\"=\"C:\\\\\"
\"Parm2enc\"=hex:
\"Parm1enc\"=hex:

[HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce]
\"applicaties voor schoollan installeren\"=\"c:\\setup.bat\"
" | sed -e 's/$/@/' | tr @ \\r > /tmp/regedit1.reg #
echo "REGEDIT4@
@" | tr @ \\r > /tmp/regedit0.reg

if [ -s /tmp/regedit1.reg ]
then
   if [ -f /mnt/hd/autoexec.bat ]
   then
       if ! grep -q patch.reg /mnt/hd/autoexec.bat
       then
	    (echo "IF EXIST C:\PATCH.REG REGEDIT /L:C:\WINDOWS\SYSTEM.DAT /R:C:\WINDOWS\USER.DAT C:\patch.reg@" 
	    echo "IF EXIST C:\PATCH.REG DEL C:\PATCH.REG@"
	    ) | tr @ \\r >>/mnt/hd/autoexec.bat
       fi
       if [ ! -s /mnt/hd/patch.reg ]; then cp /tmp/regedit0.reg /mnt/hd/patch.reg; fi
       cat /tmp/regedit1.reg >>/mnt/hd/patch.reg
       rm /tmp/regedit[01].reg
   elif [ -f /mnt/hd/windows/system.dat ]
   then
       cp /mnt/hd/windows/system.dat /mnt/hd/windows/system.000
       cat /tmp/regedit[01] >/tmp/regedit.reg ; rm -f /tmp/regedit[01].reg
       /usr/bin/regedit -f /mnt/hd/windows/system.dat -i /tmp/regedit.reg > /dev/null 2>&1
       rm /tmp/regedit.reg
   fi
fi
